A. Winner
time limit per test:1 second
memory limit per test:64 megabytes
input:standard input
output:standard output

The winner of the card game popular in Berland "Berlogging" is determined according to the following rules. If at the end of the game there is only one player with the maximum number of points, he is the winner. The situation becomes more difficult if the number of such players is more than one. During each round a player gains or loses a particular number of points. In the course of the game the number of points is registered in the line "name score", where name is a player's name, and score is the number of points gained in this round, which is an integer number. If score is negative, this means that the player has lost in the round. So, if two or more players have the maximum number of points (say, it equals to m) at the end of the game, than wins the one of them who scored at least m points first. Initially each player has 0 points. It's guaranteed that at the end of the game at least one player has a positive number of points.

Input

The first line contains an integer number n (1  ≤  n  ≤  1000), n is the number of rounds played. Then follow n lines, containing the information about the rounds in "name score" format in chronological order, where name is a string of lower-case Latin letters with the length from 1 to 32, and score is an integer number between -1000 and 1000, inclusive.

Output

Print the name of the winner.

Examples
Input
3 
mike 3
andrew 5
mike 2
Output
andrew
Input
3 
andrew 3
andrew 2
mike 5
Output
andrew

题目链接:http://codeforces.com/problemset/problem/2/A

题意:

给出一些列的名字和分数!正的表示加分,负的表示减分! 求最终分数最大的人的名字;

如果分数最大的人有多个,输出最先达到最大分数的人!

代码如下:

 #include <bits/stdc++.h>
using namespace std;
map<string, int> a,b;
string s[];
int main()
{
int x[];
int n;
cin >> n;
for(int i = ; i <= n; i++)
{
cin >> s[i] >> x[i];
a[s[i]]+=x[i];
}
int maxx = ;
for(int i = ; i <= n; i++)
{
if(a[s[i]] > maxx)
maxx = a[s[i]];
} for(int i = ; i <= n; i++)
{
b[s[i]]+=x[i];
if((b[s[i]]>=maxx) && (a[s[i]]>=maxx))//在最终分数是最大的人中,选首先达到最大分数的人
{
cout << s[i];
break;
}
}
return ;
}
B. The least round way
time limit per test:2 seconds
memory limit per test:64 megabytes
input:standard input
output:standard output

There is a square matrix n × n, consisting of non-negative integer numbers. You should find such a way on it that

  • starts in the upper left cell of the matrix;
  • each following cell is to the right or down from the current cell;
  • the way ends in the bottom right cell.

Moreover, if we multiply together all the numbers along the way, the result should be the least "round". In other words, it should end in the least possible number of zeros.

Input

The first line contains an integer number n (2 ≤ n ≤ 1000), n is the size of the matrix. Then follow n lines containing the matrix elements (non-negative integer numbers not exceeding 109).

Output

In the first line print the least number of trailing zeros. In the second line print the correspondent way itself.

Examples
Input
3 
1 2 3
4 5 6
7 8 9
Output
0 
DDRR

题目链接:http://codeforces.com/problemset/problem/2/B

题目大意

给定一个N*N的格子,每个格子里有一个非负数,要求你找出从左上角到右下角的一条路径,使得它满足路径上的格子里的数全部乘起来的积尾部0最少 题解

如果要产生0肯定是2*5得出来的,最终的乘积可以表示为2^x*5^y*C,那么零的个数就是min(x,y)。我们可以先对每个格子里的数预处理下,计算出2和5的个数来,然后DP分别求出2和5的最小个数然后选两者中的最小值,输出路径方法没啥说的,很传统~~还有一个要注意的问题就是如果某个格子的数字为0的情况,这个需要特殊判断一下,我们可以把它当做10,如果最后的结果0的个数大于1则直接输出尾部0的个数为1即可

下面给出AC代码:

 #include <bits/stdc++.h>
using namespace std;
#define MAXN 1005
#define INF 0x7fffffff
int path[MAXN][MAXN][];
int dp[MAXN][MAXN][],a[MAXN][MAXN][],n;
int zerox,zeroy,x;
string s;
bool flag;
int main()
{
scanf("%d",&n);
flag=false;
for(int i=;i<n;i++)
for(int j=;j<n;j++)
{
scanf("%d",&x);
if(!x)
{
a[i][j][]=a[i][j][]=;
zerox=i,zeroy=j,flag=true;
}
else
{
while(x%==) {a[i][j][]++;x/=;}
while(x%==) {a[i][j][]++,x/=;}
}
}
for(int k=;k<;k++)
for(int i=;i<n;i++)
for(int j=;j<n;j++)
{
int ans=INF;
if(i==&&j==) ans=;
if(i!=&&dp[i-][j][k]<ans) ans=dp[i-][j][k];
if(j!=&&dp[i][j-][k]<ans) ans=dp[i][j-][k],path[i][j][k]=;
dp[i][j][k]=ans+a[i][j][k];
}
int k=dp[n-][n-][]<dp[n-][n-][]?:;
if(flag&&dp[n-][n-][k]>)
{
for(int i=;i<zeroy;i++)
s+="R";
for(int i=;i<zerox;i++)
s+="D";
for(int i=;i<n-zeroy-;i++)
s+="R";
for(int i=;i<n-zerox-;i++)
s+="D";
cout<<<<endl<<s<<endl;
}
else
{
int i=n-,j=n-;
while(i>||j>)
{
if(path[i][j][k]==)
s+="R",j--;
else
s+="D",i--;
}
reverse(s.begin(),s.end());
cout<<dp[n-][n-][k]<<endl<<s<<endl;
}
return ;
}
C. Commentator problem
time limit per test:1 second
memory limit per test:64 megabytes
input:standard input
output:standard output

The Olympic Games in Bercouver are in full swing now. Here everyone has their own objectives: sportsmen compete for medals, and sport commentators compete for more convenient positions to give a running commentary. Today the main sport events take place at three round stadiums, and the commentator's objective is to choose the best point of observation, that is to say the point from where all the three stadiums can be observed. As all the sport competitions are of the same importance, the stadiums should be observed at the same angle. If the number of points meeting the conditions is more than one, the point with the maximum angle of observation is prefered.

Would you, please, help the famous Berland commentator G. Berniev to find the best point of observation. It should be noted, that the stadiums do not hide each other, the commentator can easily see one stadium through the other.

Input

The input data consists of three lines, each of them describes the position of one stadium. The lines have the format x,  y,  r, where (x, y) are the coordinates of the stadium's center ( -  103 ≤ x,  y ≤ 103), and r (1 ≤ r  ≤ 103) is its radius. All the numbers in the input data are integer, stadiums do not have common points, and their centers are not on the same line.

Output

Print the coordinates of the required point with five digits after the decimal point. If there is no answer meeting the conditions, the program shouldn't print anything. The output data should be left blank.

Examples
Input
0 0 10 
60 0 10
30 30 10
Output
30.00000 0.00000

题目链接:http://codeforces.com/problemset/problem/2/C

题目大意:

有3个圆,求一点a,使点a对三个圆的视角相等(过a做圆的两条切线,此两切线的夹角即为视角)。若有多点视角相等,则取视角最大的点。

设三个圆的半径分别为r1,r2,r3。设点a到三个圆的圆心距离分别为d1,d2,d3。

即目标是2*arcsin(r1/d1) = 2*arcsin(r2/d2) = 2*arcsin(r3/d3)。即r1/d1 = r2/d2 = r3/d3

那么这就是解析几何的问题了,就是列出坐标系,一顿算呗。应该很难算。但是算出公式直接给程序就行了。

看到网上还有一种方法,就是一种随机的算法。

从一个初始的解开始逐步逼近最优解。

当迭代了若干步之后,估值函数的值仍然较大时,则不存在解。

最开始,我取的估值函数cost = fabs(ang1-ang2) + fabs(ang2-ang3) + fabs(ang3-ang1). 其中ang1 ang2 ang3就是用arcsin求出来的。

这样的问题就是可能会带来比较大的误差,因为要计算的arcsin的值可能很小,所以一开始一直都没法AC。

后来我把估值函数cost 取为cost = (d1/r1-d2/r2)^2 + (d2/r2-d3/r3)^2 + (d3/r3-d1/r1)^2,效果就好一些,就AC了。

总而言之呢,这种随机算法的题目就是很蛋疼了。但是在蛋疼的基础上,还是可以采取一些办法去减小误差的。

下面给出AC代码:

 #include <bits/stdc++.h>
using namespace std; struct pt {
double x;
double y;
double r;
}; pt mkp(double x, double y) {
pt ret;
ret.x = x;
ret.y = y;
return ret;
} double dis(pt a, pt b) {
return sqrt((a.x-b.x)*(a.x-b.x) + (a.y-b.y)*(a.y-b.y));
} double cost(pt *p, double x, double y) {
double ang[];
for (int i = ; i < ; i++) ang[i] = dis(p[i], mkp(x, y)) / p[i].r; double diff[];
for (int i = ; i < ; i++) diff[i] = ang[i] - ang[(i+)%]; double ret = ;
for (int i = ; i < ; i++) ret += diff[i] * diff[i]; return ret;
} const int dx[] = {, , -, };
const int dy[] = {, , , -};
const double err = 1e-;
int main() {
pt p[];
for (int i = ; i < ; i++) scanf("%lf %lf %lf", &(p[i].x), &(p[i].y), &(p[i].r)); pt ans;
ans.x = (p[].x + p[].x + p[].x) / 3.0;
ans.y = (p[].y + p[].y + p[].y) / 3.0;
double ncost = cost(p, ans.x, ans.y); pt tmp;
double step = 1.0;
bool flag = false;
for (int i = ; i < && ncost > err; i++) {
flag = false;
for (int k = ; k < ; k++) {
tmp.x = ans.x + step * ((double)dx[k]);
tmp.y = ans.y + step * ((double)dy[k]); if (ncost > cost(p, tmp.x, tmp.y)) {
ncost = cost(p, tmp.x, tmp.y);
ans = tmp;
flag = true;
}
}
if (!flag) step *= 0.5;
} if (cost(p, ans.x, ans.y) <= err) printf("%.5lf %.5lf\n", ans.x, ans.y);
return ;
}

最新文章

  1. python 输出乱码
  2. HDU 5039 Hilarity
  3. Beta Round #9 (酱油杯noi考后欢乐赛)PLQ和他的小伙伴们
  4. Google研究员Ilya Sutskever:成功训练LDNN的13点建议
  5. 对MMU段式转换的理解
  6. HttpClient4.0
  7. 值得关注的10个python语言博客(转)
  8. QTP脚本汇总比较有价值
  9. iOS子线程更新UI的两种方法
  10. 姑娘你大胆地往前走——答大二学生XCL之八问
  11. 记录一个使用HttpClient过程中的一个bug
  12. FileOutputSream文件字节输出流
  13. WPF 开源项目
  14. appium+python自动化42-微信公众号 (可能以后会遇到也遇到切换不了webview的问题 记录再此 还没试)
  15. TFTP(Trivial File Transfer Protocol,简单文件传输协议)
  16. Google ProtocolBuffers2.4.1应用说明(一)
  17. [转载] 我的WafBypass之道(SQL注入篇)
  18. 洛谷 P3373 【模板】线段树 2 解题报告
  19. HDU4336:Card Collector(min-max容斥)
  20. (转)从Python的0.1输出0.1000000000000001说浮点数的二进制

热门文章

  1. 【python】input、int、if-else、注释、while、module(random.randint())语法示例
  2. java8 新特性入门 stream/lambda
  3. 链表创建和链表遍历算法的演示_C语言
  4. Windows编程之进程遍历(C++实现)
  5. JDK动态代理[1]----代理模式实现方式的概要介绍
  6. DNS查询的工作原理
  7. 用python爬整本小说写入txt文件
  8. JavaScript调试技巧
  9. Android 执行 adb shell 命令
  10. Asp.net IIS Express 无法启动 解决办法